jQuery(function($) {
  $(".drpager-page").bind('focus', function(e) {
	this.select();
	$(this).addClass('drpager-page-has-focus');
  }).bind('blur', function(e) {
	$(this).removeClass('drpager-page-has-focus');
  }).bind('keydown', function(e) {
	  switch(e.keyCode) {
	    case 13:
          var self = $(this);
          var id = self.attr('name');
          var state = Drupal.settings.drpager[id];
          var page = isNaN(self.val()) ? 0 : parseInt(self.val()) - 1;
          if (page < 0) {
            page = 0;
          } else if (page >= state.total){
		    page = state.total - 1;
		  }
	      document.location = state.url.replace(/drpagerpage/, page);
		  e.preventDefault();
	      return false;
	    case 38:    // up key
		  drpagerPageStep(this, 1);
		  return true;
	    case 40:    // down key
          drpagerPageStep(this, -1);
          return true;
	    case 33:    // page up
          drpagerPageStep(this, 5);
          return true;
	    case 34:    // page down
          drpagerPageStep(this, -5);
          return true;
	  }
  });
  // patch up first/previous/next/last link title attribute
  // if they are not set.
  $(".pager .pager-first a").each(function(){
	if (!this.title) {
	  this.title = Drupal.t("Go to first page");
	}
  });
  $(".pager .pager-previous a").each(function(){
	if (!this.title) {
	  this.title = Drupal.t("Go to previous page");
	}
  });
  $(".pager .pager-next a").each(function(){
	if (!this.title) {
	  this.title = Drupal.t("Go to next page");
	}
  });
  $(".pager .pager-last a").each(function(){
	if (!this.title) {
	  this.title = Drupal.t("Go to last page");
	}
  });
});


function drpagerPageStep(el, step) {
  var self = jQuery(el);
  var id = self.attr('name');
  var state = Drupal.settings.drpager[id];
  var page = isNaN(self.val()) ? 1 : parseInt(self.val());
  page += step;
  if (page < 1) {
    page = 1;
  } else if (page > state.total){
    page = state.total;
  }
  self.val(page);
}